SystemOrganization addCategory: #ConfigurationOfLoom!

Object subclass: #ConfigurationOfLoom
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfLoom'!

!ConfigurationOfLoom class methodsFor: 'development support' stamp: 'AlexandreBergel 9/5/2012 10:42'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfLoom class methodsFor: 'private' stamp: 'AlexandreBergel 9/5/2012 10:42'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfLoom class methodsFor: 'private' stamp: 'AlexandreBergel 9/5/2012 10:42'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfLoom class methodsFor: 'private' stamp: 'AlexandreBergel 9/5/2012 10:42'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfLoom class methodsFor: 'metacello tool support' stamp: 'AlexandreBergel 9/5/2012 10:42'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfLoom class methodsFor: 'loading' stamp: 'AlexandreBergel 9/5/2012 10:42'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfLoom class methodsFor: 'loading' stamp: 'AlexandreBergel 9/5/2012 10:42'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfLoom class methodsFor: 'loading' stamp: 'AlexandreBergel 9/5/2012 10:42'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfLoom class methodsFor: 'accessing' stamp: 'AlexandreBergel 9/5/2012 10:42'!
project

	^self new project! !

!ConfigurationOfLoom class methodsFor: 'development support' stamp: 'AlexandreBergel 9/5/2012 10:42'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfLoom methodsFor: 'baselines' stamp: 'AlexandreBergel 9/5/2012 10:42'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/Loom'.
		spec package: 'Loom'.
		spec group: 'default' with: #('Loom' ). ].
! !

!ConfigurationOfLoom methodsFor: 'baselines' stamp: 'AlexandreBergel 9/5/2012 15:32'!
baseline02: spec
	<version: '0.2-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/Loom'.
		spec package: 'Loom'.
		spec package: 'LoomPharo'.
		spec group: 'default' with: #('Loom' ). ].
! !

!ConfigurationOfLoom methodsFor: 'symbolic versions' stamp: 'AlexandreBergel 9/12/2012 15:03'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.12'.
! !

!ConfigurationOfLoom methodsFor: 'accessing' stamp: 'AlexandreBergel 9/5/2012 10:42'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfLoom methodsFor: 'versions' stamp: 'AlexandreBergel 9/11/2012 23:19'!
version010: spec
	<version: '0.10' imports: #('0.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.9 : Minor fix when sync with VW
0.10 : Added time in the events'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '9/11/2012 23:19'.
		spec 
			package: 'Loom' with: 'Loom-AlexandreBergel.10';
			package: 'LoomPharo' with: 'LoomPharo-AlexandreBergel.5'. ].
! !

!ConfigurationOfLoom methodsFor: 'versions' stamp: 'AlexandreBergel 9/12/2012 15:03'!
version011: spec
	<version: '0.11' imports: #('0.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.10 : Added time in the events
0.11 : Added a strategy to acquire threads. It simplifies the profiler'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '9/12/2012 15:03'.
		spec 
			package: 'Loom' with: 'Loom-AlexandreBergel.11';
			package: 'LoomPharo' with: 'LoomPharo-AlexandreBergel.5'. ].
! !

!ConfigurationOfLoom methodsFor: 'versions' stamp: 'AlexandreBergel 9/12/2012 15:45'!
version012: spec
	<version: '0.12' imports: #('0.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.11 : Added a strategy to acquire threads. It simplifies the profiler
0.12 : Added acquiring process strategy. Useful for testing and simulating'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '9/12/2012 15:45'.
		spec 
			package: 'Loom' with: 'Loom-AlexandreBergel.12';
			package: 'LoomPharo' with: 'LoomPharo-AlexandreBergel.6'. ].
! !

!ConfigurationOfLoom methodsFor: 'versions' stamp: 'AlexandreBergel 9/5/2012 14:40'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.1 : First shoot!! Get a couple of green tests '.
		spec author: 'AlexandreBergel'.
		spec timestamp: '9/5/2012 14:40'.
		spec package: 'Loom' with: 'Loom-AlexandreBergel.2'. ].
! !

!ConfigurationOfLoom methodsFor: 'versions' stamp: 'AlexandreBergel 9/5/2012 15:33'!
version02: spec
	<version: '0.2' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.1 : First shoot!! Get a couple of green tests 
0.2 : Started to work on a Spec-based UI'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '9/5/2012 15:33'.
		spec package: 'Loom' with: 'Loom-AlexandreBergel.3'. ].
! !

!ConfigurationOfLoom methodsFor: 'versions' stamp: 'AlexandreBergel 9/5/2012 15:35'!
version03: spec
	<version: '0.3' imports: #('0.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.2 : Started to work on a Spec-based UI
0.3 : Working on the UI'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '9/5/2012 15:35'.
		spec 
			package: 'Loom' with: 'Loom-AlexandreBergel.3';
			package: 'LoomPharo' with: 'LoomPharo-AlexandreBergel.1'. ].
! !

!ConfigurationOfLoom methodsFor: 'versions' stamp: 'AlexandreBergel 9/5/2012 19:46'!
version04: spec
	<version: '0.4' imports: #('0.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.3 : Working on the UI
0.4 : Working on a simple UI that lists the processes'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '9/5/2012 19:46'.
		spec 
			package: 'Loom' with: 'Loom-AlexandreBergel.4';
			package: 'LoomPharo' with: 'LoomPharo-AlexandreBergel.2'. ].
! !

!ConfigurationOfLoom methodsFor: 'versions' stamp: 'AlexandreBergel 9/6/2012 09:28'!
version05: spec
	<version: '0.5' imports: #('0.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.4 : Working on a simple UI that lists the processes
0.5 : Worked on the inspector. Added an exported '.
		spec author: 'AlexandreBergel'.
		spec timestamp: '9/6/2012 09:28'.
		spec 
			package: 'Loom' with: 'Loom-AlexandreBergel.5';
			package: 'LoomPharo' with: 'LoomPharo-AlexandreBergel.3'. ].
! !

!ConfigurationOfLoom methodsFor: 'versions' stamp: 'AlexandreBergel 9/6/2012 10:15'!
version06: spec
	<version: '0.6' imports: #('0.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.5 : Worked on the inspector. Added an exported 
0.6 : Migrating Loom to VW'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '9/6/2012 10:15'.
		spec 
			package: 'Loom' with: 'Loom-AlexandreBergel.6';
			package: 'LoomPharo' with: 'LoomPharo-AlexandreBergel.4'. ].
! !

!ConfigurationOfLoom methodsFor: 'versions' stamp: 'AlexandreBergel 9/6/2012 10:25'!
version07: spec
	<version: '0.7' imports: #('0.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.6 : Migrating Loom to VW
0.7 : Making the test platform independent'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '9/6/2012 10:25'.
		spec 
			package: 'Loom' with: 'Loom-AlexandreBergel.7';
			package: 'LoomPharo' with: 'LoomPharo-AlexandreBergel.5'. ].
! !

!ConfigurationOfLoom methodsFor: 'versions' stamp: 'AlexandreBergel 9/11/2012 22:24'!
version08: spec
	<version: '0.8' imports: #('0.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.7 : Making the test platform independent
0.8 : Added events and comments'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '9/11/2012 22:24'.
		spec 
			package: 'Loom' with: 'Loom-AlexandreBergel.8';
			package: 'LoomPharo' with: 'LoomPharo-AlexandreBergel.5'. ].
! !

!ConfigurationOfLoom methodsFor: 'versions' stamp: 'AlexandreBergel 9/11/2012 22:37'!
version09: spec
	<version: '0.9' imports: #('0.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.8 : Added events and comments
0.9 : Minor fix when sync with VW'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '9/11/2012 22:37'.
		spec 
			package: 'Loom' with: 'Loom-AlexandreBergel.9';
			package: 'LoomPharo' with: 'LoomPharo-AlexandreBergel.5'. ].
! !
